<template>
  <v-form ref="form" v-model="valid" lazy-validation>
    <v-card>
      <v-card-title>
        <span v-if="form.productId" class="text-h5">Chỉnh sửa sản phẩm</span>
        <span v-else class="text-h5">Thêm sản phẩm</span>
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="6">
              <v-col cols="12">
                <v-text-field
                  label="Tên sản phẩm"
                  outlined
                  dense
                  :rules="rules.productName"
                  v-model="form.productName"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  type="number"
                  label="Giá bán"
                  outlined
                  dense
                  :rules="rules.productPrice"
                  v-model="form.productPrice"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-textarea
                  label="Mô tả"
                  outlined
                  dense
                  v-model="form.description"
                ></v-textarea>
              </v-col>
              <v-col cols="12">
                <v-select
                  label="Trạng thái"
                  dense
                  outlined
                  :items="isSalesItems"
                  :rules="rules.isSales"
                  v-model="form.isSales"
                ></v-select>
              </v-col>
            </v-col>
            <v-col cols="6">
              <v-col cols="12">
                <img :src="productImage" height="300" width="500" />
              </v-col>
              <v-col cols="12">
                <v-btn
                  color="primary"
                  small
                  tile
                  class="white--text"
                  @click="$refs.fileInput.click()"
                  >Upload</v-btn
                >
                <v-btn
                  color="red darken-1"
                  small
                  tile
                  class="white--text"
                  @click="onClearImage"
                  >Xóa file</v-btn
                >
                <v-text-field
                  placeholder="tên file upload"
                  outlined
                  dense
                  :readonly="true"
                  class="mt-1"
                  v-model="fileName"
                ></v-text-field>
                <input
                  type="file"
                  ref="fileInput"
                  class="d-none"
                  accept="image/x-png,image/jpg,image/jpeg"
                  @change="onFileSelected"
                />
              </v-col>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-grey lighten-4"
          @click="$router.push({ name: 'ProductListPage' })"
        >
          Hủy
        </v-btn>
        <v-btn color="red lighten-2 white--text" @click="onSave"> Lưu </v-btn>
      </v-card-actions>
    </v-card>
  </v-form>
</template>

<script>
import productService from "../../../services/productService";

export default {
  props: {
    productData: {
      type: Object,
      required: false,
      default: {},
    },
  },
  data() {
    return {
      valid: false,
      isSalesItems: [
        {
          text: "Đang bán",
          value: 1,
        },
        {
          text: "Ngừng bán",
          value: 0,
        },
        {
          text: "Hết hàng",
          value: 2,
        },
      ],
      form: {
        productId: "",
        productName: "",
        productPrice: "",
        productImage: "",
        image: '',
        description: "",
        isSales: "",
      },
      rules: {
        productName: [
          (v) => {
            if (!v) return "Vui lòng nhập tên sản phẩm.";
            if (!!v && v.length < 5) return "Tên phải lớn hơn 5 ký tự.";
            return true;
          },
        ],
        productPrice: [
          (v) => {
            if (!v) return "Giá bán không được để trống.";
            if (v < 0) return "Giá bán không được nhỏ hơn 0.";
            return true;
          },
        ],
        isSales: [
          (v) => {
            if (v === null || v === "") return "Trạng thái không được trống.";
            return true;
          },
        ],
      },
      fileName: "",
    };
  },
  computed: {
    productImage() {
      return this.form.productImage
        ? this.form.productImage
        : "/images/no_image.png";
    },
  },
  watch: {
    productData(newVal, oldVal) {
      this.form = newVal;
      this.fileName = newVal.productImage;
    },
  },
  methods: {
    onSave() {
      const isValid = this.$refs.form.validate();
      if (!isValid) return false;
      this.$store.commit("loading", true);
      const formData = new FormData();
      for (let key in this.form) {
        formData.append(
          key
            .split(/(?=[A-Z])/)
            .join("_")
            .toLowerCase(),
          this.form[key]
        );
      }

      if (this.form.productId) {
        productService
          .update(this.form.productId, formData)
          .then((response) => {
            this.$store.commit("loading", false);
            this.$store.commit("showMessageSuccess", "Cập nhật thành công");
          })
          .catch((error) => {
            let msgError = "";
            if (error.response.status === 422) {
              const dataErrors = error.response.data.errors;
              let errors = [];
              for (const [key, value] of Object.entries(dataErrors)) {
                errors.push(value);
              }
              msgError = errors.toString();
            } else {
              msgError = error.response.data.message;
            }
            this.$store.commit("loading", false);
            this.$store.commit("showMessageError", msgError);
          });
      } else {
        productService
          .add(formData)
          .then((response) => {
            this.$store.commit("loading", false);
            this.$store.commit("showMessageSuccess", "Thêm thành công");
            this.$router.push({ name: 'ProductListPage' });
          })
          .catch((error) => {
            let msgError = "";
            if (error.response.status === 422) {
              const dataErrors = error.response.data.errors;
              let errors = [];
              for (const [key, value] of Object.entries(dataErrors)) {
                errors.push(value);
              }
              msgError = errors.toString();
            } else {
              msgError = error.response.data.message;
            }
            this.$store.commit("loading", false);
            this.$store.commit("showMessageError", msgError);
          });
      }
    },
    onFileSelected(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length) return;
      const file = files[0];
      if (file.size > 2097152) {
        this.$refs.fileInput.value = null;
        this.$store.commit("showMessageError", "Dung lượng hình không quá 2Mb");
        return;
      }
      this.fileName = file.name;
      let reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = (e) => {
        new Promise((resolve, reject) => {
          let img = new Image();
          img.onload = () => {
            resolve(img);
          };
          img.src = e.target.result;
        }).then((img) => {
          if (img.height > 1024 || img.width > 1024) {
            this.$store.commit(
              "showMessageError",
              "Kích thước không quá 1024px."
            );
          } else {
            this.form.productImage = img.src;
            this.form.image = file;
          }
        });
      };

      reader.onerror = (e) => {
        console.error(e);
      };
    },
    onClearImage() {
      this.fileName = "";
      this.form.image = "";
      this.form.productImage = "";
      this.$refs.fileInput.value = null;
    },
  },
  created() {},
};
</script>
